/* Services configuration */

#ifndef CONFIG_H
#define CONFIG_H

/* The remote server and port to use, and the password for the link. */
#define REMOTE_SERVER	"irc.dragonfire.net"
#define REMOTE_PORT	7000
#define PASSWORD	"flogness"

/* Information about us as a server. */
#define SERVER_NAME	"services.dragonfire.net"
#define SERVER_DESC	"Dragonfire's IRC services"
#define SERVICES_USER	"service"
#define SERVICES_HOST	"dragonfire.net"

/* Directory for data files */
#define SERVICES_DIR	"/usr/local/lib/services"

/* Log filename in services directory */
#define LOG_FILENAME	"services.log"

/* Database filenames */
#define NICKSERV_DB	"nick.db"
#define CHANSERV_DB	"chan.db"
#define AKILL_DB	"akill.db"


/* Delay (in seconds) between database updates.  (Incidentally, this is
 * also how often we check for nick/channel expiration.) */
#define UPDATE_TIMEOUT	300

/* Delay (in seconds) before a NickServ-collided nick is released. */
#define RELEASE_TIMEOUT	60

/* Delay (in seconds) before we time out on a read and do other stuff,
 * like checking NickServ timeouts. */
#define READ_TIMEOUT	15


/* Size of input buffer */
#define BUFSIZE		1024

/* Maximum length of a channel name */
#define CHANMAX		64

/* Maximum length of a nickname */
#define NICKMAX		32

/* Maximum length of a password */
#define PASSMAX		32


#endif	/* CONFIG_H */
