/* OperServ */

#include "services.h"

#include "os-help.c"

/* Nick for OperServ */
const char s_OperServ[] = "OperServ";

static int nakill = 0;
static int akill_size = 0;
static char **akills = NULL;


static void add_akill(const char *mask);
static int del_akill(const char *mask);

/*************************************************************************/

void operserv(const char *source, char *buf)
{
    char *cmd;
    char *s, *chan, *nick;
    int i;


    log("OperServ: %s: %s", source, buf);
    cmd = strtok(buf, " ");


    if (!cmd) {

	return;

    } else if (stricmp(cmd, "\1PING") == 0) {

	if (!(s = strtok(NULL, "")))
	    s = "\1";
	notice(s_OperServ, source, "\1PING %s", s);

    } else if (stricmp(cmd, "MODE") == 0) {

	s = strtok(NULL, "");
	if (!s)
	    return;
	send_cmd(s_OperServ, "MODE %s", s);

    } else if (stricmp(cmd, "KICK") == 0) {

	chan = strtok(NULL, " ");
	nick = strtok(NULL, " ");
	s = strtok(NULL, "");
	if (!chan || !nick || !s)
	    return;
	send_cmd(s_OperServ, "KICK %s %s :%s (%s)", chan, nick, source, s);

    } else if (stricmp(cmd, "HELP") == 0) {

	cmd = strtok(NULL, " ");

	if (!cmd)
	    notice_list(s_OperServ, source, os_help);
	else if (stricmp(cmd, "MODE") == 0)
	    notice_list(s_OperServ, source, mode_help);
	else if (stricmp(cmd, "KICK") == 0)
	    notice_list(s_OperServ, source, kick_help);
	else if (stricmp(cmd, "AKILL") == 0)
	    notice_list(s_OperServ, source, akill_help);
	else
	    notice(s_OperServ, source,
				"No help available for command \2%s\2", cmd);

    } else if (stricmp(cmd, "AKILL") == 0) {

	cmd = strtok(NULL, " ");
	if (stricmp(cmd, "ADD") == 0) {
	    if (s = strtok(NULL, " ")) {
		if (strchr(s, '@'))
		    strlower(strchr(s, '@'));
		add_akill(s);
		notice(s_OperServ, source, "%s added to AKILL list.", s);
	    } else {
		notice(s_OperServ, source, "Syntax: AKILL ADD <mask>");
	    }

	} else if (stricmp(cmd, "DEL") == 0) {
	    s = strtok(NULL, " ");
	    if (s = strtok(NULL, " ")) {
		if (strchr(s, '@'))
		    strlower(strchr(s, '@'));
		if (del_akill(s)) {
		    notice(s_OperServ, source, "%s removed from AKILL list.", s);
		    send_cmd(SERVER_NAME, "RAKILL :%s", s);
		} else {
		    notice(s_OperServ, source, "%s not found on AKILL list.", s);
		}
	    } else {
		notice(s_OperServ, source, "Syntax: AKILL DEL <mask>");
	    }

	} else if (stricmp(cmd, "LIST") == 0) {
	    s = strtok(NULL, " ");
	    if (!s)
		s = "*";
	    if (strchr(s, '@'))
		strlower(strchr(s, '@'));
	    notice(s_OperServ, source, "Current AKILL list:");
	    for (i = 0; i < nakill; ++i) {
		if (!s || match_wild(s, akills[i]))
		    notice(s_OperServ, source, "%s", akills[i]);
	    }
	} else {
	    notice(s_OperServ, source,
"Syntax: AKILL {ADD|DEL|LIST} [mask]");
	    notice(s_OperServ, source,
"For help: /msg %s HELP AKILL", s_OperServ);
	}

    } else if (!is_services_op(source)) {

	notice(s_OperServ, source,
"Unrecognized command.  Type \"/msg %s HELP\" for help.", s_OperServ);

    } else if (stricmp(cmd, "UPDATE") == 0) {

	notice(s_OperServ, source, "Updating databases.");
	save_data = 1;

    } else if (stricmp(cmd, "QUIT") == 0) {

	quitmsg = malloc(32 + strlen(source));
	if (!quitmsg)
	    quitmsg = "QUIT command received, but out of memory!";
	else
	    sprintf(quitmsg, "QUIT command received from %s", source);
	quitting = 1;

    } else if (stricmp(source, "Alcan") != 0) {

	notice(s_OperServ, source,
"Unrecognized command.  Type \"/msg %s HELP\" for help.", s_OperServ);

    } else if (stricmp(cmd, "LISTCHANS") == 0) {

	send_channel_list(source);

    } else if (stricmp(cmd, "LISTCHAN") == 0) {

	char *chan = strtok(NULL, " ");
	if (chan)
	    send_channel_users(source, chan);
	else
	    notice(s_OperServ, source, "Syntax error.");

    } else if (stricmp(cmd, "LISTUSERS") == 0) {

	send_user_list(source);

    } else if (stricmp(cmd, "MATCHWILD") == 0) {

	char *pat = strtok(NULL, " ");
	char *str = strtok(NULL, " ");
	if (pat && str)
	    notice(s_OperServ, source, "%d", match_wild(pat, str));
	else
	    notice(s_OperServ, source, "Syntax error.");

    } else if (stricmp(cmd, "COME") == 0 &&
		((s = strtok(NULL, "")) && strnicmp(s, "ON IN ", 6) == 0)) {

	/* So I'm silly.  Sue me. ;P */

	s += 6;
	send_cmd(s_NickServ, "JOIN %s", s);
	send_cmd(s_ChanServ, "JOIN %s", s);
	send_cmd(s_OperServ, "MODE %s +oo NickServ ChanServ", s);
	sleep(2);
	send_cmd(s_ChanServ, "PRIVMSG %s :Ah, thanks, Oper.", s);
	sleep(1);
	send_cmd(s_NickServ, "PRIVMSG %s :Hi, everyone!  How are you all?", s);
	sleep(2);
	send_cmd(s_ChanServ, "PRIVMSG %s :Nick: Ahgo jmp in a lka.e :P", s);
	sleep(3);
	send_cmd(s_NickServ, "KICK %s NickServ :Fine. :P <splash>", s);
	sleep(6);
	send_cmd(s_ChanServ,
		"PRIVMSG %s :Sorry about that.  He can get a little punchy "
		"sometimes, and that's about the only way to get his "
		"attention...", s);
	sleep(1);
	send_cmd(s_ChanServ, "PRIVMSG %s :Later.", s);
	sleep(1);
	send_cmd(s_ChanServ, "PART %s", s);

    } else {

	notice(s_OperServ, source,
"Unrecognized command.  Type \"/msg %s HELP\" for help.", s_OperServ);

    }
}

/*************************************************************************/

/* Is the given nick a Services op? */

int is_services_op(const char *nick)
{
    NickInfo *ni;

    if (	stricmp(nick, "Alcan") != 0 &&
		stricmp(nick, "Darien") != 0
    )
	return 0;
    if ((ni = findnick(nick)) && (ni->flags & NI_IDENTIFIED))
	return 1;
    return 0;
}

/*************************************************************************/
/****************************** AKILL stuff ******************************/
/*************************************************************************/

void load_akill()
{
    FILE *f = fopen(AKILL_DB, "r");
    int i;

    if (!f) {
	log_perror("Can't read AKILL database " AKILL_DB);
	return;
    }
    nakill = fgetc(f) * 256 + fgetc(f);
    if (nakill < 8)
	akill_size = 16;
    else
	akill_size = 2*nakill;
    akills = smalloc(sizeof(char *) * akill_size);
    for (i = 0; i < nakill; ++i) {
	int len = fgetc(f) * 256 + fgetc(f);
	akills[i] = smalloc(len);
	if (len != fread(akills[i], 1, len, f)) {
	    log_perror("Read error on AKILL database " AKILL_DB);
	    nakill = i;
	    fclose(f);
	    return;
	}
    }
    fclose(f);
}

/*************************************************************************/

void save_akill()
{
    FILE *f;
    int i;

    remove(AKILL_DB ".save");
    rename(AKILL_DB, AKILL_DB ".save");
    f = fopen(AKILL_DB, "w");
    if (!f) {
	log_perror("Can't write to AKILL database " AKILL_DB);
	return;
    }
    fputc(nakill/256, f); fputc(nakill & 255, f);
    for (i = 0; i < nakill; ++i) {
	int len;
	len = strlen(akills[i])+1;	/* include terminating null */
	fputc(len/256, f); fputc(len & 255, f);
	if (len != fwrite(akills[i], 1, len, f)) {
	    log_perror("Write error on AKILL database " AKILL_DB);
	    fclose(f);
	    rename(AKILL_DB ".save", AKILL_DB);
	    return;
	}
    }
    fclose(f);
    remove(AKILL_DB ".save");
}

/*************************************************************************/

/* Does the user match any AKILLs? */
int check_akill(const char *nick, const char *username, const char *host)
{
    char buf[512];
    int i;

    if (*username == '~')
	++username;
    strscpy(buf, username, sizeof(buf)-2);
    i = strlen(buf);
    buf[i++] = '@';
    strlower(strscpy(buf+i, host, sizeof(buf)-i));
    for (i = 0; i < nakill; ++i) {
	if (match_wild(akills[i], buf)) {
	    send_cmd(SERVER_NAME,
			"KILL %s :%s (You are banned from this network)",
			nick, s_OperServ);
	    send_cmd(SERVER_NAME,
			"AKILL %s %s :You are banned from this network",
			host, username);
	    return 1;
	}
    }
    return 0;
}

/*************************************************************************/

static void add_akill(const char *mask)
{
    if (nakill >= akill_size) {
	if (akill_size < 8)
	    akill_size = 8;
	else
	    akill_size *= 2;
	akills = srealloc(akills, sizeof(char *) * akill_size);
    }
    akills[nakill++] = sstrdup(mask);
}

/*************************************************************************/

/* Return whether the mask was found in the AKILL list. */

static int del_akill(const char *mask)
{
    int i;

    for (i = 0; i < nakill && strcmp(akills[i], mask) != 0; ++i)
	;
    if (i < nakill) {
	--nakill;
	if (i < nakill)
	    bcopy(akills+i+1, akills+i, sizeof(char *) * (nakill-i));
	return 1;
    } else {
	return 0;
    }
}

/*************************************************************************/
