/* Routines for sending stuff to the network */

#include "services.h"

/*************************************************************************/

/* Send a command to the server. */
void send_cmd(const char *source, const char *fmt,...)
{
    va_list args;
    char buf[2048];	/* better not get this big... */

    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    if (source)
	sockprintf(servsock, ":%s %s\r\n", source, buf);
    else
	sockprintf(servsock, "%s\r\n", buf);
}

/*************************************************************************/

/* Send out a WALLOPS. */
void wallops(const char *fmt,...)
{
    va_list args;
    char buf[2048];

    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    sockprintf(servsock, ":%s WALLOPS :%s\r\n", SERVER_NAME, buf);
}

/*************************************************************************/

/* Send a NOTICE from the given source to the given nick. */
void notice(const char *source, const char *dest, const char *fmt,...)
{
    va_list args;
    char buf[2048];

    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    sockprintf(servsock, ":%s NOTICE %s :%s\r\n", source, dest, buf);
}

/* Send a NULL-terminated array of text as NOTICEs. */
void notice_list(const char *source, const char *dest, const char **text)
{
    while (*text)
	sockprintf(servsock, ":%s NOTICE %s :%s\r\n", source, dest, *text++);
}

/*************************************************************************/

/* Send a PRIVMSG from the given source to the given nick. */
void privmsg(const char *source, const char *dest, const char *fmt,...)
{
    va_list args;
    char buf[2048];

    va_start(args, fmt);
    vsprintf(buf, fmt, args);
    sockprintf(servsock, ":%s PRIVMSG %s :%s\r\n", source, dest, buf);
}
